<!DOCTYPE html>
<html lang="en" xmlns="http://www.w3.org/1999/xhtml" xmlns:th="https://www.thymeleaf.org">
<head>
    <meta charset="UTF-8">
    <title th:replace="header :: title(Notes)">Files</title>
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link th:replace="header.html :: css">
</head>
<body class="p-3 mb-2 bg-light text-black">
<div class="container">
    <div th:replace="header.html :: logout"></div>
    <div class="tab-content" id="nav-tabContent">
        <nav th:replace="header.html :: navigation(notes)"></nav>
        <p></p>
        <div th:if="${param.save != null and param.save[0] == 'success'}"class="alert alert-success alert-dismissible fade show" role="alert">
            Your note has been saved.
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div th:if="${param.delete != null and param.delete[0] == 'success'}" class="alert alert-success alert-dismissible fade show" role="alert">
            Your note has been successfully deleted.
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div th:if="${param.save != null and param.save[0] == 'edit-success'}" class="alert alert-success alert-dismissible fade show" role="alert">
            Your changes have been saved.
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div th:if="${param.error != null}" class="alert alert-danger alert-dismissible fade show" role="alert">
            An error has occurred. Please try again.
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div class="tab-pane fade show active" th:fragment="content" id="nav-notes" role="tabpanel" aria-labelledby="nav-notes-tab">
            <button style="margin: 0.25em;" type="button" id="add-note-button" class="btn btn-info float-right" onclick="showNoteModal()">
                + Add a New Note
            </button>
            <div class="table-responsive">
                <table class="table table-striped" id="userTable">
                    <thead>
                    <tr>
                        <th style="width: 20%" scope="col"></th>
                        <th style="width: 20%" scope="col">Title</th>
                        <th style="width: 60%" scope="col">Description</th>
                    </tr>
                    </thead>
                    <tbody th:remove="all-but-first">
                    <tr class="note" th:each="note : ${noteList}">
                        <td>
                            <button type="button" class="btn btn-success note-edit-button"
                                    th:noteId="${note.id}"
                                    th:noteTitle="${note.title}"
                                    th:noteDescription="${note.description}"
                                    th:onclick="javascript:showNoteModal(this.getAttribute('noteId'), this.getAttribute('noteTitle'), this.getAttribute('noteDescription'))">
                                Edit
                            </button>
                            <form action="#" th:action="@{'/notes/delete/' + ${note.getId()}}" method="POST" hidden="true" aria-hidden="true">
                                <button type="submit" class="btn btn-danger" id="deleteNote" >Delete</button>
                            </form>
                            <button type="submit" class="btn btn-danger" id="delete-note-button" onclick="$('#deleteNote').click();">Delete</button>

                        </td>
                        <th class="note-title" scope="row" th:text="${note.getTitle()}" th:id="${note.getId()}">Example Note Title</th>
                        <td class="note-description" th:text="${note.getDescription()}">Example Note Description </td>
                    </tr>
                    <tr class="note">
                        <td>
                            <button type="button" class="btn btn-success">Edit</button>
                            <a class="btn btn-danger" >Delete</a>
                        </td>
                        <th scope="row">Example Note Title</th>
                        <td>Example Note Description </td>
                    </tr>
                    </tbody>
                </table>
            </div>
            <div class="modal fade" id="noteModal" tabindex="-1" role="dialog" aria-labelledby="noteModalLabel" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="noteModalLabel">Note</h5>
                            <button type="button" class="close" id="close-modal-button" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <form action="#" method="POST" th:action="@{/notes}" th:object="${note}">
                                <input type="hidden" name="id" id="note-id">
                                <div class="form-group">
                                    <label for="note-title" class="col-form-label">Title</label>
                                    <input type="text" name= "noteTitle" class="form-control" id="note-title" th:field="${note.title}" maxlength="20" required>
                                </div>
                                <div class="form-group">
                                    <label for="note-description" class="col-form-label">Description</label>
                                    <textarea class="form-control" name="noteDescription" id="note-description" th:field="${note.description}" rows="5" maxlength="1000" required></textarea>
                                </div>
                                <button id="noteSubmit" type="submit" class="d-none"></button>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" id="cancel-button" data-dismiss="modal">Close</button>
                            <button type="button" class="btn btn-primary"  id="save-button" onclick="$('#noteSubmit').click();">Save changes</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<div th:replace="header.html :: scripts"></div>
<!--For opening the note modal-->
<script type="text/javascript">
            // For opening the note modal
            function showNoteModal(noteId, noteTitle, noteDescription) {
                $('#note-id').val(noteId ? noteId : '0');
                $('#note-title').val(noteTitle ? noteTitle : '');
                $('#note-description').val(noteDescription ? noteDescription : '');
                let noteModal = new Modal('noteModal');
                noteModal.show();
                //$('#noteModal').modal('show');
            }
</script>
</body>
</html>